package com.swop;

/**
 * -----------------------------------------------------------------------------
 * Class ApplicationProperties
 *
 * Die Klasse ermittelt "Properties" aus einer Datei im Filesystem. 
 *
 * Author:  Volker Paul, NESCO Solutions GmbH
 * 
 * Last changes:
 * 26.12.2007, created, Volker Paul
 * -----------------------------------------------------------------------------
 */
import java.util.*;
import java.io.*;

public class ApplicationProperties extends java.util.Properties {
    ArrayList orderedKeys = new ArrayList();
    public ApplicationProperties() {
      super();
    }
    
    public ApplicationProperties(java.util.Properties defaults) {
      super(defaults);
    }
    
    public synchronized Iterator getKeysIterator() {
      return orderedKeys.iterator();
    }
  
    public static ApplicationProperties load(String name) throws IOException {
        ApplicationProperties props = null;
        //java.io.InputStream is = SapProperties.class.getResourceAsStream(name);
        java.io.InputStream is = new FileInputStream(name);
        if ( is != null ) {
            props = new ApplicationProperties();
            props.load(is);
            return props;
        }
        else {
            if ( ! name.startsWith("/") ) {
                return load ("/" + name);
            }
            else {
                throw new IOException("> Properties could not be loaded !");
            }
        }
    }
    
    public synchronized Object put(Object key, Object value) {
        Object obj = super.put(key, value);
        orderedKeys.add(key);
        return obj;
    }
    
    public synchronized Object remove(Object key) {
        Object obj = super.remove(key);
        orderedKeys.remove(key);
        return obj;
    }	
}
