package com.swop;

import org.jdom.Document;
import org.jdom.JDOMFactory;
import org.jdom.input.SAXBuilder;
import org.jdom.input.DOMBuilder;
import org.jdom.output.XMLOutputter;
import org.jdom.output.Format;

import java.io.File;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.IOException;

import org.apache.log4j.Logger;

public class JDOMParser 
{
    private static Logger logger  = Logger.getLogger(JDOMParser.class); // log4j logger definition

  private Document document = null;
  
  public Document parse(String filename)
    throws Exception
  {
    Document document = getJDomDocument(filename);
    File file = new File(filename);
    System.out.println("Parsing "+filename);
    return document;
  }
  
  public void writeXmlOutput(Document pDoc, String pFileName)
  {
    try
    {
      FileOutputStream xmlOut=new FileOutputStream(pFileName);
      XMLOutputter outputter=new XMLOutputter();
      //outputter.setEncoding("UTF-8");
      Format format = outputter.getFormat();
      format.setEncoding("UTF-8");
      outputter.output(pDoc, xmlOut);
      xmlOut.close();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }
  
  public Document getJDomDocument(String pFileName)
      throws Exception
  {
    SAXBuilder saxBuilder = new SAXBuilder();
    Document doc = saxBuilder.build(new File(pFileName));
    
    return doc;
  }
}