package com.swop.config;

/** 
 * -----------------------------------------------------------------------------
 * Class ApplicationStatics
 *
 * Logging module class definition for use of log4j - 
 * reads the log4j property file
 *
 * Author:  Volker Paul - NESCO Solutions GmbH
 * 
 * Last changes:
 * 26.12.2007 created  Volker Paul 
 * -----------------------------------------------------------------------------
 */

import com.swop.ApplicationProperties;
import org.apache.log4j.Appender;
import org.apache.log4j.FileAppender;
import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.SimpleLayout;
import java.io.FileWriter;
import java.io.BufferedWriter;
import java.io.IOException;

public class ApplicationStatics {
    public static Appender LOG4J_APPENDER=initLog4j();
	
    public static final String APP_FINISHED_FLAG_SUCCESS = "success";
    public static final String APP_FINISHED_FLAG_FAILURE = "failure";
    public static final String APP_FINISHED_FLAG_LOGICERR = "logicerror";
    public static final String PROPFILE = "application.properties";
    public static final String PROP_KEY_APP_USER="appUser";
    public static final String PROP_KEY_APP_PWD="appPwd";
    public static final String PROP_KEY_APP_HOST="appHost";
    public static final String PROP_KEY_JDBC_URL="jdbcUrl";
    public static final String PROP_KEY_JDBC_DRIVER="jdbcDriver";
    
    public static final Long APPLICATION_USER_ID = new Long(0);

    public static final String PROP_KEY_KEY_MODE    = "translationKey";
    public static final String PROP_KEY_MODE_ID     = "id";
    public static final String PROP_KEY_MODE_TEXT   = "text";

    // -----------------------------------------------------------------------------------------------------
    // initialize class
    // -----------------------------------------------------------------------------------------------------
    public ApplicationStatics() {
    }

    // -----------------------------------------------------------------------------------------------------
    // initialize log4j - logging module
    // -----------------------------------------------------------------------------------------------------
    private static FileAppender initLog4j() {
        PropertyConfigurator.configure("log4j.properties");
        SimpleLayout layout = new SimpleLayout();
    
        FileAppender appender = null;
        try { ApplicationProperties sapprop2 = ApplicationProperties.load(ApplicationStatics.PROPFILE);
              String log4jfile = sapprop2.getProperty("LOG4J_FILE");
              // true = append to file ; false = overwrite file
              appender = new FileAppender(layout,log4jfile,true);
        } catch(Exception e) {
          e.printStackTrace();
        }
        return appender;
    }
}
